***********************************************************************
* SUPERBASIC EXTENSION TO PRINT HEX REPRESENTATION OF FP NUMBER
*
* VERSION: 1.00
* CREATED:       18-AUG-1988 BY B.H.DENCHFIELD
* LAST MODIFIED: 18-AUG-1988 BY B.H.DENCHFIELD
***********************************************************************
BPINIT  EQU     $110
ADDPROC MOVE.W  BPINIT,A0
        LEA.L   PROCDEF,A1      ;POINT TO PROC/FN DEFINITION
        JSR     (A0)            ;USE VECTORED UTILITY TO LINK PROC/FN
        RTS
*
* DATA BLOCK LISTING NEW PROCEDURES/FUNCTIONS
*
PROCDEF DC.W    1               ;NUMBER OF PROCEDURES
*
        DC.W    FPTOHEX-*       ;RELATIVE LOCATION OF START
        DC.B    7,'FPTOHEX'     ;NAME OF PROCEDURE
*
        DC.W    0               ;FLAG FOR END OF PROCEDURES
*
        DC.W    0               ;NUMBER OF FUNCTIONS
        DC.W    0               ;FLAG FOR END OF FUNCTIONS
***********************************************************************
* ROUTINE TO PRINT #1 HEX REPRESENTAION OF FP NUMBER PASSED AS A
* PARAMETER
*
* REF: ADVANCED QL MACHINE CODE
*      ADAM DENNING
*
* VERSION: 1.00
* CREATED:       18-AUG-1988 BY B.H.DENCHFIELD
* LAST MODIFIED: 18-AUG-1988 BY B.H.DENCHFIELD
***********************************************************************
CAGTFP  EQU     $114
BVCHBAS EQU     $30
CHLENCH EQU     $28
UTMTEXT EQU     $D0
IOSBYTE EQU     $05
FPTOHEX MOVE.W  CAGTFP,A2       ;GET ARGUMENT AS FP
        JSR     (A2)            ;NOTE: NO ARGUMENT CHECKING!
        MOVEQ   #0,D1           ;CLEAR D1
        MOVE.W  0(A6,A1.L),D1   ;EXPONENT IN D1
        MOVE.L  2(A6,A1.L),D2   ;MANTISSA IN D2
        BSR     PT_HEX1         ;PRINT THEM
        MOVEQ   #0,D0           ;CLEAR D0
        RTS                     ;RETURN TO BASIC
*
PT_HEX1 MOVE.L  BVCHBAS(A6),A2  ;GET BASE OF CHANNELS
        ADD.L   #CHLENCH,A2     ;CHANNEL 1 DEF BLOCK
        MOVE.L  0(A6,A2.L),A0   ;GET CHANNEL ID IN A0
        LEA.L   GEN_BUF+2,A1    ;GET READY TO STORE STRING
        BSR     PT_HEX2         ;CONVERT EXPONENT TO HEX CHARS
        MOVE.W  ' ',(A1)+       ;2 SPACES
        MOVE.L  D2,D1           ;FOLLOWED BY MANTISSA
        BSR     PT_HEX2
        LEA.L   GEN_BUF,A1      ;STORE STRING LENGTH...
        MOVE.W  #18,(A1)
        MOVE.W  UTMTEXT,A2      ;...AND PRINT IT
        JSR     (A2)
        MOVEQ   #IOSBYTE,D0     ;FOLLOWED BY NEW LINE
        MOVEQ   #10,D1
        MOVEQ   #-1,D3
        TRAP    #3
        RTS
*
PT_HEX2 MOVEQ   #7,D0           ;8 CONVERSION PER LONG WORD
H_LOOP  ROL.L   #4,D1
        MOVE.B  D1,D3
        AND.L   #$F,D3
        ADD.B   #'0',D3         ;CONVERT TO ASCII
        CMP.B   #'9',D3
        BLE     H_NUM
        ADD.B   #7,D3
H_NUM   MOVE.B  D3,(A1)+        ;STORE CHARACTER
        DBRA    D0,H_LOOP
        RTS
*
GEN_BUF DS.B    38                
                   
